module AST.Relational where


import AST.Vector
import AST.Prolog

--

-- Note that operands are represented as
-- lists, but may be more correct to represent
-- them as binary CUnion Relational Relational

-- This implies that we have the (non enforced)
-- invariant:
--     r = CUnion l ||
--     r = CIntercestion l ||
--     r = CConcat l -> lenght (l) >= 2
-- If this is not honored undefined things will
-- happen.

data Relational =
      CUnion        [Relational]
    | CIntersection [Relational]
    | CConcat       [Relational]
    | FK            Vector
    | FI            Int
    | FW            Perm
    | FConv         Relational
    | FPred         Predicate
    | F0
      deriving (Eq, Show)

-- Jeje
-- instance Functor Relational
