module AST.Vector where

import Data.List

import qualified AST.Prolog as Prolog

-- A vector of Prolog Terms
-- This datatype should be temporal.

type Vector = [Prolog.Term Int]

-- A selection is represented like CPerm  [2,3,8]
-- Which means 2->1, 3->2, 8-> 3
data Perm = CPerm [Int]
                 deriving (Eq, Show)

invert :: Perm -> Perm
invert (CPerm l) = CPerm $ snd . unzip . sort $ zip l [1..]
