module Engine.Tagging

where

import AST.Vector
import AST.Prolog
import AST.Relational

data TagType = Freeze
	     | Rewrite
	       deriving (Eq, Show)

data Tag ty = CTag ty TagType
	      deriving (Eq, Show)

type Tag1 = Tag Relational

data TaggedRelational a = 
      CUnion'        [TaggedRelational a] a
    | CIntersection' [TaggedRelational a] a
    | CConcat'       [TaggedRelational a] a
    | FK'            Vector a
    | FI'            Int a
    | FW'            Perm a
    | FConv'         (TaggedRelational a) a
    | FPred'         Predicate a
    | F0'            a
      deriving (Eq, Ord, Show)

