-----------------------------------------------------------------
-- |
-- Module      : Shell.Interactive.Command
-- Copyright   : (c) Babel Group 2004
-- License     : GPL
--
-- Maintainer  : egallego@babel.ls.fi.upm.es
-- Stability   : experimental
-- Portability : portable
-- Last modified: 05 Oct 2004, 17:12
--
-- Defines interactive shell datatypes.
-- 
-----------------------------------------------------------------

module Shell.Interactive.Command 
where

-- | Internal commands.
data InternalC = Quit 
	       | Load [String]
	       deriving(Eq, Show)

-- | Global commands.
data Command = ShellCommand InternalC
	     | Query String
	     | Empty
	       deriving(Eq, Show)

parseCommand :: String -> [String] -> Maybe InternalC
parseCommand "quit" [] = return Quit
parseCommand "load" fn = return $ Load fn
parseCommand _ _    = fail ""
