-----------------------------------------------------------------
-- |
-- Module      : Translator.String.Prolog
-- Copyright   : (c) Babel Group 2004
-- License     : GPL
--
-- Maintainer  : egallego@babel.ls.fi.upm.es
-- Stability   : very experimental
-- Portability : portable
-- Last modified: 01 Oct 2004, 17:09
--
-- Prolog Lexer and Parser.
--
-----------------------------------------------------------------
module Translator.String.Prolog
where

import AST.Prolog

import Translator
import Translator.String.Prolog.Lexer
import Translator.String.Prolog.Syntax

import Compiler.Module  (emptyModule)

import Control.Monad.State
import Control.Monad.Error

instance Translator String Predicate (Clause String) where
    translate s =
        let lexed   = alexScanTokens s
            parsed  = (runErrorT (prolog_parser lexed))
            program = execState parsed emptyModule
            result  = evalState parsed emptyModule in
        case result of
          Left e  -> Left e
          Right _ -> Right program

trans_clause :: String -> Either String (Clause String)
trans_clause s =
        let lexed   = alexScanTokens s
            parsed  = (runErrorT (clause_parser lexed))
            program = execState parsed emptyModule
            result  = evalState parsed emptyModule in
        result 

trans_term :: String -> Either String (Term String)
trans_term s =
        let lexed   = alexScanTokens s
            parsed  = (runErrorT (term_parser lexed))
            program = execState parsed emptyModule
            result  = evalState parsed emptyModule in
        result 

