{
--
-- This module contains a Prolog lexer.

module Translator.String.Prolog.Lexer

where

}

%wrapper "basic"

  $d     = 0-9                          -- digits
  $l     = [a-zA-Z0-9]                  -- alphabetic characters
  $lcap  = [A-Z]                        -- capital letters
  $lscap = [a-z0-9]                     -- small capital letters
  $syms  = [ \. \, \( \) \[ \] \|]      -- Symbols we support
  @dsyms = ":-"                         -- Double symbols, as regexp.

tokens :-

  [ \  \t \n]+           ; -- white space
  \%.*\n                 ; -- comments

  [$lcap\_][$l\_]*       { \s -> PTVar   s      }
  $lscap[$l\_]*          { \s -> PTConst s      }
  $syms | @dsyms         { \s -> PTSym   s      }


{

--

-- Token data type.

data PrologToken =
    PTSym     [Char] |
    PTVar     [Char] |
    PTConst   [Char]

    deriving(Eq, Show)

}
